import unittest

from locatar import Locatar
from apartament import Apartament
from costPrecedent import CostPrecedent
from instiintare import Instiintare
from repLocatar import RepLocatar
from repApartament import RepApartament
from repCostPrecedent import RepCostPrecedent
from repInstiintare import RepInstiintare

class Controller:

    def __init__(self):

        """
        Descriere: Constructor explicit CLASA Apartament
        Preconditii: construieste un obiect de tipul Apartament
        Date: nrAp, proprietar, pers, calorifere, mp
        Postconditii: nrAp-integer, proprietar - String, pers-integer, calorifere-integer, mp-integer
        Rezultate: creearea unui obiect de tipul clasei cu atributele date
        """

        self.repLocatar = RepLocatar()
        self.repApartament = RepApartament()
        self.repCostPrecedent = RepCostPrecedent()
        self.repInstiintare = RepInstiintare()

    """
    Descriere: lista instiintarilor(proprietar, nrAp, coCurent, coTotal)
    """
    def listaInstiintariPlata(self):   #afisez doar coCurent sau coTotal
        listaInstiintari = []
        instiintari = self.repInstiintare.getAll()
        for proprietar, instiintare in instiintari.iteritems():
            listaInstiintari.append(instiintare)
            print instiintare.getProprietar() +' '+"Cost curent:"+ str(instiintare.getCostCurent())+' '+"Cost Total:"+str(instiintare.getCostTotal())
        return listaInstiintari

    """
    Descriere: lista locatarilor(nume, prenume, datan, venit, nrAp)
    """
    def listaLocatariVenitMic(self):
        listaLocatari = []
        locatari = self.repLocatar.getAll()
        for proprietar, locatar in locatari.iteritems():
            if locatar.getVenit() < 500:
                listaLocatari.append(locatar)
        return listaLocatari

    """
    Descriere: lista locatarilor restantieri din CostPrecedent(proprietar, nrAp, coPrec, platit)
    """
    def listaLocatariRestantieri(self):
        listaRestantieri = []
        costPrecedent = self.repCostPrecedent.getAll()
        for proprietar, locatar in costPrecedent.iteritems():
            if locatar.getPlatit() == 0:   #adica nu a platit costul Precedent
                listaRestantieri.append(locatar)
        return listaRestantieri

    """
    Descriere: lista instiintarilor care au coTotal egal cu cost(proprietar, nrAp, coCurent, coTotal=cost)
    """
    def listaLocatariCoTotalDat(self, cost):
        listaLocatari = []
        instiintari = self.repInstiintare.getAll()
        for proprietar, locatar in instiintari.iteritems():
            if locatar.getCostTotal() == cost:
                 listaLocatari.append(locatar)
        return listaLocatari

    """
    Descriere: afisarea caracteristicilor locatarului cu numele dat(nume, prenume, datan, venit, nrAp)
    """
    def getLocatarCaracteristici(self, nume):
        return self.repLocatar.findByProprietar(nume)

    """
    Descriere: afisarea raspunsului daca locatarului din costPrecedent a platit coPrec
    """
    def getLocatarAPlatit(self, nume):
        return self.repCostPrecedent.findByProprietarPlatit(nume)


"""class TestController(unittest.TestCase):
    def setUp(self):
        self.controller = Controller()

    def testlistaInstiintariPlata(self):
        listaInstiintari = self.controller.listaInstiintariPlata()
        self.assertEqual(len(listaInstiintari), 3)
        self.assertEqual(listaInstiintari[0].getProprietar(), 'Migea Alin')
        self.assertEqual(listaInstiintari[0].getNrAp(), 1)

    def testlistaLocatariVenitMic(self):
        listaLocatari = self.controller.listaLocatariVenitMic()
        self.assertEqual(len(listaLocatari), 1)
        self.assertEqual(listaLocatari[0].getProprietar(), 'Migea Alin')
        self.assertEqual(listaLocatari[0].getVenit(), 150)

    def testlistaLocatariRestantieri(self):
        listaLocatariR = self.controller.listaLocatariRestantieri()
        self.assertEqual(len(listaLocatariR), 3)
        self.assertEqual(listaLocatariR[0].getProprietar(), 'Migea Alin')
        self.assertEqual(listaLocatariR[0].getCostPrec(), 95)

    def testlistaLocatariCoTotalDat(self):
        listaLocatariCoTotal = self.controller.listaLocatariCoTotalDat(226)
        self.assertEqual(len(listaLocatariCoTotal), 1)
        self.assertEqual(listaLocatariCoTotal[0].getProprietar(), 'Migea Alin')
        self.assertEqual(listaLocatariCoTotal[0].getCostTotal(), 226)

    def testGetLocatarCaracteristici(self):
        locatari = self.controller.repLocatar.getAll()
        assertEqual(self.controller.getLocatarCaracteristici('Migea Alin'), locatari['Migea Alin'])

    def testGetLocatarAPlatit(self):
        costuriPrecedente = self.controller.repCostPrecedent.getAll()
        assertEqual(self.controller.getLocatarAPlatit('Migea Alin'), costuriPrecedente['Migea Alin'].getPlatit())

if __name__ == '__main__':
    unittest.main()
"""
