import unittest
from apartament import Apartament

class RepApartament:

    def __init__(self):
        """
        Descriere: Constructor explicit CLASA RepApartament
        Preconditii: construieste un obiect de tipul RepApartament
        Date: listAp
        Postconditii: listAp-Apartament[]
        Rezultate: creearea unui obiect de tipul clasei cu atributele specificate
        """
        self.listAp = {}
        self.read("Apartamente.txt")

    def getAll(self):                  #dictionarul de apartamente
        return self.listAp

    def add(self, apartament):         #adaugare apartament
        self.listAp[apartament.getProprietar()] = apartament

    #def remove(self, apartament):      #stergem apartament
    #    del self.listAp[apartament.getProprietar()]

    def findByProprietar(self, proprietar):
        return self.listAp[proprietar]              #returneaza obiectul Apartament asociat proprietarului

    def read(self, inputFile):
        file = open(inputFile)
        lines = file.readlines()
        for line in lines:
            lineElements = line.split()             #desparte dupa spatiu
            proprietar = str(lineElements[0]+' '+lineElements[1])
            nrAp = int(lineElements[2])
            pers = int(lineElements[3])
            calorifere = int(lineElements[4])
            mp = int(lineElements[5])
            platit = int(lineElements[6])
            self.add(Apartament(proprietar, nrAp, pers, calorifere, mp, platit)) #adaugare obiect Apartament in dictionar

"""
class TestRepApartament(unittest.TestCase):
    def setUp(self):
        self.repApartament = RepApartament()

    def testGetAll(self):
        apartamente = self.repApartament.getAll()
        self.assertEqual(len(apartamente), 3)
        self.assertEqual(apartamente['Migea Alin'].getProprietar(), 'Migea Alin')
        self.assertEqual(apartamente['Ungur Alex'].getProprietar(), 'Ungur Alex')
        self.assertEqual(apartamente['Migea Adrian'].getProprietar(), 'Migea Adrian')

    def testFindByProprietar(self):
        self.assertEqual(self.repApartament.findByProprietar('Migea Alin').getNrAp(), 1)
        self.assertEqual(self.repApartament.findByProprietar('Migea Adrian').getNrAp(), 3)


    def testAdd(self):
        self.repApartament.add( Apartament('Colcer Paul', 4, 3, 5, 30, 1) )
        apartamente = self.repApartament.getAll()
        self.assertEqual(len(apartamente), 4)
        self.assertEqual(self.repApartamente.findByProprietar('Colcer Paul').getMP(), 30)

if __name__ == '__main__':
    unittest.main()
"""