import unittest
from costPrecedent import CostPrecedent

class RepCostPrecedent:

    costPerMp = 2
    def __init__(self):
        """
        Descriere: Constructor explicit CLASA RepCostPrecedent
        Preconditii: construieste un obiect de tipul RepPrecedent
        Date: listCostPrecedent
        Postconditii: listcostPrecedent-costPrecedent[]
        Rezultate: creearea unui obiect de tipul clasei cu atributele specificate
        """
        self.listCostPrecedent = {}
        self.read("Apartamente.txt")

    def getAll(self):
        return self.listCostPrecedent

    def add(self, costPrecedent):
        self.listCostPrecedent[costPrecedent.getProprietar()] = costPrecedent

    def findByProprietar(self, proprietar):
        return self.listCostPrecedent[proprietar]

    def findByProprietarPlatit(self, proprietar):   #afla daca un proprietar a platit sau nu
        return self.listCostPrecedent[proprietar].getPlatit()

    def read(self, inputFile):
        file = open(inputFile)
        lines = file.readlines()
        for line in lines:
            lineElements = line.split()             #desparte dupa spatiu
            proprietar = str(lineElements[0]+' ' +lineElements[1])
            nrAp = int(lineElements[2])
            pers = int(lineElements[3])
            calorifere = int(lineElements[4])
            mp = int(lineElements[5])
            platit = int(lineElements[6])
            coPrec = 5 * pers +  calorifere + RepCostPrecedent.costPerMp * mp
            self.add(CostPrecedent(proprietar, nrAp, coPrec, platit))

"""
class TestRepCostPrecedent(unittest.TestCase):
    def setUp(self):
        self.repCostPrecedent = RepCostPrecedent()

    def testGetAll(self):
        costuriPrecedente = self.repCostPrecedent.getAll()
        self.assertEqual(len(costuriPrecedente), 3)   #dictionarul cu costPrecedent
        self.assertEqual(costuriPrecedente['Migea Alin'].getProprietar(), 'Migea Alin')
        self.assertEqual(costuriPrecedente['Ungur Alex'].getProprietar(), 'Ungur Alex')
        self.assertEqual(costuriPrecedente['Migea Adrian'].getProprietar(), 'Migea Adrian')

    def testFindByProprietar(self):
        self.assertEqual(self.repCostPrecedent.findByProprietar('Migea Alin').getNrAp(), 1)   # obiect de tip costPrecedent
        self.assertEqual(self.repCostPrecedent.findByProprietar('Migea Adrian').getNrAp(), 3)


    def testAdd(self):
        self.repCostPrecedent.add( CostPrecedent('Colcer Paul', 4, 100, 1) )
        costuriPrecedente = self.repCostPrecedent.getAll()
        self.assertEqual(len(costuriPrecedente), 4)
        self.assertEqual(self.repCostPrecedent.findByProprietar('Colcer Paul').getCostPrec(), 100)

    def testFindByProprietarPlatit(self):
        self.repCostPrecedent.add( CostPrecedent('Nicoara Ioana', 4, 200, 1) )
        self.assertEqual(self.repCostPrecedent.findByProprietarPlatit('Nicoara Ioana'), 1)

if __name__ == '__main__':
    unittest.main()
"""