import unittest
from instiintare import Instiintare

class RepInstiintare:

    costPerMp = 2
    def __init__(self):
        """
        Descriere: CONSTRUCTOR explicit CLASA RepInstiintare
        Preconditii: construieste un obiect de tipul RepInstiintare
        Date: listInstiintare
        Postconditii: listInstiintare-Instiintare[]
        Rezultate: creearea unui obiect de tipul clasei cu atributele specificate
        """
        self.listInstiintare = {}
        self.read("Apartamente.txt")

    def getAll(self):
        return self.listInstiintare

    def add(self, instiintare):
        self.listInstiintare[instiintare.getProprietar()] = instiintare

    def findByProprietar(self, proprietar):
        return self.listaInstiintare[proprietar]

    def read(self, inputFile):
        file = open(inputFile)
        lines = file.readlines()
        for line in lines:
            lineElements = line.split()
            proprietar = str(lineElements[0]+' '+lineElements[1])
            nrAp = int(lineElements[2])
            pers = int(lineElements[3])
            calorifere = int(lineElements[4])
            mp = int(lineElements[5])
            platit = int(lineElements[6])
            if platit == 1:    #adica a platit costul Precedent
                coPrec = 0
            else:
                coPrec = 5 * pers +  calorifere + RepInstiintare.costPerMp * mp
            coCurent = pers + calorifere + RepInstiintare.costPerMp * mp
            print 'coCurent  '+str(coCurent)+'\n'
            coTotal = coPrec + coCurent
            self.add(Instiintare(proprietar, nrAp, coCurent, coTotal))


"""class TestRepInstiintare(unittest.TestCase):
    def setUp(self):
        self.repInstiintare = RepInstiintare()

    def testGetAll(self):
        instiintari = self.repInstiintare.getAll()
        self.assertEqual(len(instiintari), 3)   #dictionarul cu instiintare
        self.assertEqual(instiintari['Migea Alin'].getProprietar(), 'Migea Alin')
        self.assertEqual(instiintari['Ungur Alex'].getProprietar(), 'Ungur Alex')
        self.assertEqual(instiintari['Migea Adrian'].getProprietar(), 'Migea Adrian')

    def testFindByProprietar(self):
        self.assertEqual(self.repInstiintare.findByProprietar('Migea Alin').getNrAp(), 1)   # obiect de tip instiintare
        self.assertEqual(self.repInstiintare.findByProprietar('Migea Adrian').getNrAp(), 3)


    def testAdd(self):
        self.repInstiintare.add( Instiintare('Colcer Paul', 4, 150, 250) )
        instiintari = self.repInstiintare.getAll()
        self.assertEqual(len(instiintari), 4)
        self.assertEqual(self.repInstiintare.findByProprietar('Colcer Paul').getCostTotal(), 250)

if __name__ == '__main__':
    unittest.main()
"""