import unittest
from locatar import Locatar

class RepLocatar:

    def __init__(self):
        """
        Descriere: CONSTRUCTOR explicit CLASA RepLocatar
        Preconditii: construieste un obiect de tipul RepLocatar
        Date: listLocatoari
        Postconditii: listLocatari-Locatar[]
        Rezultate: creearea unui obiect de tipul clasei cu atributele specificate
        """
        self.listLocatari = {}                     #dictionar vid cu Locatari
        self.read("Locatari.txt")    #initializarea dictionarului

    def getAll(self):
        return self.listLocatari                   #dictionarul cu Locatari

    def add(self, locatar):
        self.listLocatari[locatar.getProprietar()] = locatar  #key-proprietar, value-obiectul locatar

    def findByProprietar(self,proprietar):
        return self.listLocatari[proprietar]        #returneaza obiectul cu key=proprietar

    def read(self, inputFile):
        file = open(inputFile)
        lines = file.readlines()
        for line in lines:
            lineElements = line.split()             #desparte dupa spatiu
            nume= str(lineElements[0])
            prenume= str(lineElements[1])
            datan = str(lineElements[2])
            venit = int(lineElements[3])
            nrAp = int(lineElements[4])
            self.add(Locatar(nume, prenume, datan, venit, nrAp)) #adaugare obiect Locatar in dictionar


"""
class TestRepLocatar(unittest.TestCase):
    def setUp(self):
        self.repLocatar = RepLocatar()

    def testGetAll(self):
        locatari = self.repLocatar.getAll()
        self.assertEqual(len(locatari), 3)
        self.assertEqual(locatari['Migea Alin'].getProprietar(), 'Migea Alin')
        self.assertEqual(locatari['Ungur Alex'].getProprietar(), 'Ungur Alex')
        self.assertEqual(locatari['Migea Adrian'].getProprietar(), 'Migea Adrian')

    def testFindByProprietar(self):
        self.assertEqual(self.repLocatar.findByProprietar('Migea Alin').getAp(), 1)
        self.assertEqual(self.repLocatar.findByProprietar('Migea Adrian').getAp(), 3)


    def testAdd(self):
        self.repLocatar.add( Locatar('Colcer','Paul', '1/1/1991', 200, 4) )
        locatari = self.repLocatar.getAll()
        self.assertEqual(len(locatari), 4)
        self.assertEqual(self.repLocatar.findByProprietar('Colcer Paul').getAp(), 4)
        #intoarece obiectul Locatar din listLocatari cu "cheia Colcer Paul" si verifica nrAp

if __name__ == '__main__':
    unittest.main()
"""